
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import "GLShip.h"



// default settings
#define	DRONE_HEALTH                    4.0f

#define	DRONE_ROT_SPEED                 2.0f
#define DRONE_MAX_SPEED                 0.005f
#define DRONE_ACCEL                     0.0001f

#define DRONE_MAX_SPEED_VARIATION       0.0005f
#define DRONE_ACCEL_VARIATION           0.00001f

#define	DRONE_BULLET_TIME               360
#define	DRONE_BULLET_OFFSET             0.1f
#define DRONE_BULLET_SPEED              0.04f
#define	DRONE_MULTIBULLET_TIME          10.0f
#define	DRONE_MULTIFLAME_TIME           4.0f

#define DRONE_COLLIDE_DISTANCE          0.2f
#define	DRONE_COLLIDE_CHECK_TIME        30.0f
#define DRONE_FLYAWAY_TIME              30.0f

// suicide drone settings
#define DRONE_SUICIDE_PROXIMITY_DIST	0.4f
#define DRONE_SUICIDE_EXPLO_DIST		0.4f
#define DRONE_SUICIDE_DAMAGE			5.0f

#define DRONE_MASS                      100.0f
#define DRONE_MASS_BOSS                 150.0f

#define DRONE_LINEAR_DAMPING            0.995f

#define	DRONE_SPREAD_ROT                15.0f
#define DRONE_SPREAD_DIST               0.15f


extern int gNumDroneShips;
extern int gDroneLevel;
extern int gNumDroneLevelsPlayed;
extern int gNumDronesDestroyed;
extern int gNumDronesKilledThisLife;
extern int gNumRandDrones;



@interface GLDroneShip : GLShip
{
@public
	
	int droneType;
	int droneDifficulty;
	
	int spriteID;
	
	float shotgunProb;
	float missileProb;
	float bulletFireTime;
	float bulletTimer;
	int numBulletsToFire;
		
	float droneCollideSize;
	
	// suicide drone specific settings
	float suicideProximity;
	float suicideExploRadius;
	float suicideExploDamage;
	
	int droneScore;
	float powerupProbability;
	
	CGPoint sideVelocity;
	
@private
	
	int numBulletsLeftToFire;
	
	float collideTimer;
	float flyAwayTimer;

}


- (void) aimAtPoint:(float)x andY:(float)y;

+ (GLDroneShip *) GLDroneShip_LaunchWithType:(int) droneType difficulty:(int)droneDiff x:(float)posX y:(float)posY sort:(int)sortDepth rot:(float)rotation;
+ (void) GLDroneShip_RunLaunching;

@end
