
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import "GLPartsShip.h"
#import "GLFont.h"
#import "GLChatIcon.h"
#import "NetMsgController.h"


#define NAMETEXT_OFFSET_X	0.1f
#define	NAMETEXT_OFFSET_Y	0.1f

#define CHAT_ICON_OFFSET_ADJUST_FROM_NAME_X	0.15f
#define CHAT_ICON_OFFSET_ADJUST_FROM_NAME_Y	0.15f


@interface GLNetShip : GLPartsShip
{
@public
	
	NSString* playername;

	GLChatIcon *pChatIcon;
	bool bChatting;
	
	int killedByUserID;
	
@protected
	bool bKillMe;	// flag that can be set by external processes to kill this ship
	
	GLFont *pNameText;	// name display for this net ship
	
	bool bNewPos;
	CGPoint msgPos;
	CGPoint msgVelocity;
	float msgRotation;
	float msgRotSpeed;
	float msgPingTime;

	float msgInputAngle;
	float msgInputMagnitude;

}


- (void) killMe;

- (void) setActive:(bool)bAlive;
- (void) setShield:(bool)bOn howLong:(float)shieldTime;

- (void) forcePos:(float)xPos andY:(float)yPos andRot:(float)rotPos;

- (void) updateFromVectorMsg:(VectorUpdatePacket *)pMsg myPing:(int)localPing;
- (void) updateFromPositionMsg:(PositionPacket *)pMsg;

- (bool) updateSprite;

+ (GLNetShip *) NetShip_LaunchWithUserID:(int)userID playerName:(NSString *)name x:(GLfloat)posX y:(GLfloat)posY sort:(int)sortDepth size:(GLfloat)scale rot:(GLfloat)rotation


@end
