
#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>
#import "GLSprite.h"


// Tmp hard-coded physics damping
#define	SHIP_LINEAR_DAMPING			0.995f
#define SHIP_ROTATIONAL_DAMPING		0.85f
//#define SHIP_ROTATIONAL_DAMPING		0.9f


@interface GLShip : GLSprite
{
@public

	float maximumSpeed;
	float maxRotSpeed;
	float curSpeed;
	float acceleration;
	
	float turnSpeed;

	float rotationTarget;
	float speedTarget;
	
	// values for physics controlled ships
	bool bUsePhysics;
	float shipMass;
	float shipRotInertia;

	bool bForcesApplied;
	bool bPrevForcesApplied;
	
	float shieldStrength;
	float maxShieldStrength;
	float shieldRechargeRate;
	float shieldDownTime;
	float shieldDownTimer;
	float shieldDisplayRatio;
	
	float specialWeaponStrength;
	float maxSpecialWeaponStrength;
	float specialWeaponRechargeRate;
	float specialWeaponFireAmount;
	float baseWeaponFireAmount;
	float specialWeaponFireTime;
	float baseWeaponFireTime;
	
	float exploScale;
	
}


- (void) setMaxSpeed:(float)maxSpeed;
- (void) setTurnSpeed:(float)rotSpeed;
- (void) setAcceleration:(float)accel;

- (void) setSpeedTarget:(float)spdTarget;
- (void) setRotationTarget:(float)rotTarget;

- (void) applyForceRot:(float)atX yPos:(float)atY angle:(float)rotAngle forceSize:(float)forceScale isContinuous:(bool)bContinuous;
- (void) applyForceVector:(float)atX yPos:(float)atY forceX:(float)xForce forceY:(float)yForce;


@end

